/*
 *  matqMath.h
 *  fp
 *
 *  Created by Robert Delaney on 5/28/13.
 *  Copyright 2013 Bob Delaney's Science Software. All rights reserved.
 *
 */

#pragma once

INT32 matqCompare(const matq& x, const matq& y);
void add(matq& z, const matq& x, const matq& y);;
void sub(matq& z, const matq& x, const matq& y);;
void mul(matq& z, const matq& x, const matq& y);
void mul(matq& z, const matq& x, const bf& y);
void mul(matq& z, const matq& x, double y);
void matqUnit(matq& z, INT32 n);
matq matqUnit(INT32 n);
void transpose(matq& z, const matq& x);
matq transpose(const matq& x);
bool trace(bf& z, const matq& x);
bf trace(const matq& x);
void matqRowAugment(matq& z, const matq& x, const matq& y);
matq matqRowAugment(const matq& x, const matq& y);
void matqColAugment(matq& z, const matq& x, const matq& y);
matq matqColAugment(const matq& x, const matq& y);
void matqGaussElim(matq& z, INT32& swapParity, const matq& x);
bool matqGaussElim(matq& z, INT32& swapParity, const char *xString);
void matqGaussElim(matq& z, const matq& x, double q);
void matqReduce(matq& z, const matq& x);
void matqNullSpace(INT32& numNV, matq& nullVectors, matq& reduced, const matq& x);
bool matqNullSpace(INT32& numNV, matq& nullVectors, matq& reduced, const char *xString);
void matqNullSpace(INT32& numNV, matq& nullVectors, matq& reduced, const matq& x, double q);
bool matqInvert(matq& z, bf& det, const matq& x);
matq matqInvert(bf& det, const matq& x);
void matqMod(matq& z, const matq& x, const mb& q);
void matqMod(matq& z, const matq& x, double q);
bool power(matq& z, const matq& x, INT32 y);
bool powerMod(matq& z, const matq& x, const mb& y, const mb& q);

